# ModelAnimationCollection

#### new Cesium.ModelAnimationCollection()
Scene/ModelAnimationCollection.js 20

A collection of active model animations. Access this using `Model#activeAnimations`.

##### See:

- Model#activeAnimations

### Members

#### animationAdded : Event
Scene/ModelAnimationCollection.js 33

The event fired when an animation is added to the collection. This can be used, for example, to keep a UI in sync.

Default Value: `new Event()`

##### Example:

    model.activeAnimations.animationAdded.addEventListener(function(model, animation) {
      console.log('Animation added: ' + animation.name);
    });

#### animationRemoved : Event
Scene/ModelAnimationCollection.js 47

The event fired when an animation is removed from the collection. This can be used, for example, to keep a UI in sync.

Default Value: `new Event()`

##### Example:

    model.activeAnimations.animationRemoved.addEventListener(function(model, animation) {
      console.log('Animation removed: ' + animation.name);
    });

#### readonly length : Number
Scene/ModelAnimationCollection.js 63

The number of animations in the collection.

### Methods

#### add(options) → ModelAnimation
Scene/ModelAnimationCollection.js 140

Creates and adds an animation with the specified initial properties to the collection.

This raises the `ModelAnimationCollection#animationAdded` event so, for example, a UI can stay in sync.

Name | Type | Description
--- | --- | ---
`options` | Object | Object with the following properties:
Name | Type | Default | Description
--- | --- | --- | ---
`name` | String |  | optional The glTF animation name that identifies the animation. Must be defined if `options.index` is `undefined`.
`index` | Number |  | optional The glTF animation index that identifies the animation. Must be defined if `options.name` is `undefined`.
`startTime` | JulianDate |  | optional The scene time to start playing the animation. When this is `undefined`, the animation starts at the next frame.
`delay` | Number | `0.0` | optional The delay, in seconds, from `startTime` to start playing.
`stopTime` | JulianDate |  | optional The scene time to stop playing the animation. When this is `undefined`, the animation is played for its full duration.
`removeOnStop` | Boolean | `false` | optional When `true`, the animation is removed after it stops playing.
`multiplier` | Number | `1.0` | optional Values greater than `1.0` increase the speed that the animation is played relative to the scene clock speed; values less than `1.0` decrease the speed.
`reverse` | Boolean | `false` | optional When `true`, the animation is played in reverse.
`loop` | ModelAnimationLoop | `ModelAnimationLoop.NONE` | optional Determines if and how the animation is looped.

##### Returns:

The animation that was added to the collection.

##### Throws:

- DeveloperError : Animations are not loaded. Wait for the `Model#readyPromise` to resolve.
- DeveloperError : options.name must be a valid animation name.
- DeveloperError : options.index must be a valid animation index.
- DeveloperError : Either options.name or options.index must be defined.
- DeveloperError : options.multiplier must be greater than zero.

##### Examples:

    // Example 1. Add an animation by name
    model.activeAnimations.add({
      name : 'animation name'
    });

    // Example 2. Add an animation by index
    model.activeAnimations.add({
      index : 0
    });

    // Example 3. Add an animation and provide all properties and events
    var startTime = Cesium.JulianDate.now();

    var animation = model.activeAnimations.add({
      name : 'another animation name',
      startTime : startTime,
      delay : 0.0,                          // Play at startTime (default)
      stopTime : Cesium.JulianDate.addSeconds(startTime, 4.0, new Cesium.JulianDate()),
      removeOnStop : false,                 // Do not remove when animation stops (default)
      multiplier : 2.0,                        // Play at double speed
      reverse : true,                       // Play in reverse
      loop : Cesium.ModelAnimationLoop.REPEAT      // Loop the animation
    });

    animation.start.addEventListener(function(model, animation) {
      console.log('Animation started: ' + animation.name);
    });
    animation.update.addEventListener(function(model, animation, time) {
      console.log('Animation updated: ' + animation.name + '. glTF animation time: ' + time);
    });
    animation.stop.addEventListener(function(model, animation) {
      console.log('Animation stopped: ' + animation.name);
    });

#### addAll(options) → Array.<ModelAnimation>
Scene/ModelAnimationCollection.js 218

Creates and adds an animation with the specified initial properties to the collection for each animation in the model.

This raises the `ModelAnimationCollection#animationAdded` event for each model so, for example, a UI can stay in sync.

Name | Type | Description
--- | --- | ---
`options` | Object | optional Object with the following properties:
Name | Type | Default | Description
--- | --- | --- | ---
`startTime` | JulianDate |  | optional The scene time to start playing the animations. When this is `undefined`, the animations starts at the next frame.
`delay` | Number | `0.0` | optional The delay, in seconds, from `startTime` to start playing.
`stopTime` | JulianDate |  | optional The scene time to stop playing the animations. When this is `undefined`, the animations are played for its full duration.
`removeOnStop` | Boolean | `false` | optional When `true`, the animations are removed after they stop playing.
`multiplier` | Number | `1.0` | optional Values greater than `1.0` increase the speed that the animations play relative to the scene clock speed; values less than `1.0` decrease the speed.
`reverse` | Boolean | `false` | optional When `true`, the animations are played in reverse.
`loop` | ModelAnimationLoop | `ModelAnimationLoop.NONE` | optional Determines if and how the animations are looped.

##### Returns:

An array of `ModelAnimation` objects, one for each animation added to the collection. If there are no glTF animations, the array is empty.

##### Throws:

- DeveloperError : Animations are not loaded. Wait for the `Model#readyPromise` to resolve.
- DeveloperError : options.multiplier must be greater than zero.

##### Example:

    model.activeAnimations.addAll({
      multiplier : 0.5,                        // Play at half-speed
      loop : Cesium.ModelAnimationLoop.REPEAT      // Loop the animations
    });

#### contains(animation) → Boolean
Scene/ModelAnimationCollection.js 301

Determines whether this collection contains a given animation.

Name | Type | Description
--- | --- | ---
`animation` | ModelAnimation | The animation to check for.

##### Returns:

`true` if this collection contains the animation, `false` otherwise.

#### get(index) → ModelAnimation
Scene/ModelAnimationCollection.js 326

Returns the animation in the collection at the specified index. Indices are zero-based and increase as animations are added. Removing an animation shifts all animations after it to the left, changing their indices. This function is commonly used to iterate over all the animations in the collection.

Name | Type | Description
--- | --- | ---
`index` | Number | The zero-based index of the animation.

##### Returns:

The animation at the specified index.

##### Example:

    // Output the names of all the animations in the collection.
    var animations = model.activeAnimations;
    var length = animations.length;
    for (var i = 0; i < length; ++i) {
      console.log(animations.get(i).name);
    }

#### remove(animation) → Boolean
Scene/ModelAnimationCollection.js 262

Removes an animation from the collection.

This raises the `ModelAnimationCollection#animationRemoved` event so, for example, a UI can stay in sync.

An animation can also be implicitly removed from the collection by setting `ModelAnimation#removeOnStop` to `true`. The `ModelAnimationCollection#animationRemoved` event is still fired when the animation is removed.

Name | Type | Description
--- | --- | ---
`animation` | ModelAnimation | The animation to remove.

##### Returns:

`true` if the animation was removed; `false` if the animation was not found in the collection.

##### Example:

    var a = model.activeAnimations.add({
      name : 'animation name'
    });
    model.activeAnimations.remove(a); // Returns true

#### removeAll()
Scene/ModelAnimationCollection.js 283

Removes all animations from the collection.

This raises the `ModelAnimationCollection#animationRemoved` event for each animation so, for example, a UI can stay in sync.